""" Some non oriented graphs to test our graph functions
author : Laure Gonnord, june 2021
"""

from LibGraphes import Graph


g1 = Graph({"a": ["d"],
            "b": ["c"],
            "c": ["b", "d", "e"],
            "d": ["a", "c"],
            "e": ["c"],
            "f": []
            })

g2 = Graph({"r3": ["r1", "r2"],
            "r2": ["r3", "r1", "c", "a"],
            "r1": ["r3", "r2", "c"],
            "c": ["r1", "r2", "b", "a", "d", "e"],
            "b": ["a", "c", "d", "e"],
            "e": ["b", "c", "d"],
            "a": ["b", "c", "d", "r2"],
            "d": ["a", "b", "c", "e"]
            })

try:
    notagraph = Graph({"a": ["d"],
                       "b": ["c"],
                       "c": ["b"],
                       "d": []  # a should appear here.
                       })
except AssertionError:
    print("The constructor checks consistancy : notagraph undefined")

g3 = Graph({1: [2, 3],
            2: [1, 4, 5],
            3: [1, 5, 7, 8],
            4: [2],
            5: [2, 3, 6],
            6: [5],
            7: [3, 8],
            8: [3, 7]
            })

# graphes du TD1
g4 = Graph({1: [4, 3, 2],
            2: [1, 7],
            3: [1, 4, 5, 6],
            4: [1, 3, 8],
            5: [3, 6],
            6: [3, 5, 7],
            7: [2, 6],
            8: [4]
            })

g5 = Graph({1: [2, 7, 8],
            2: [1, 3, 4],
            3: [2, 8, 10],
            4: [2, 8],
            5: [6, 8, 9, 10, 11],
            6: [5, 7, 8],
            7: [1, 6, 9],
            8: [1, 3, 4, 5, 6],
            9: [5, 7, 11],
            10: [3, 5],
            11: [5, 9]
            })

print("Inclusion of ExGraphs: g1 to g5 properly defined as Graphs")
