""" File to test LibGraphes
author : Laure Gonnord, june 2021
usage python3 TestLib.py (requires graphviz)
"""

from LibGraphes import Graph
from ExGraphes import g1, g2, g3, g4, g5


def main():
    """
    Main function to demo the lib
    """
    # g is a dict implementing the "list of successors " rep of graph
    # nodes can be strings or ints (I prefer ints)
    gdict = {"a": ["d"],
             "b": ["c"],
             "c": ["b", "d", "e"],
             "d": ["a", "c"],
             "e": ["c"],
             "f": []
             }

    mygraph = Graph(gdict)

    print("Vertices of mygraph:")
    print(mygraph.vertices())
    
    print("Edges of mygraph:")
    print(mygraph.edges())
    
    print("Add vertex:")
    mygraph.add_vertex("z")
    
    print("Vertices of mygraph:")
    print(mygraph.vertices())
    
    print("Add an edge:")
    mygraph.add_edge(("a","z"))
    print("Add an edge:")
    mygraph.add_edge(("a", "a"))
    print("Vertices of mygraph:")
    print(mygraph.vertices())
    
    print("Edges of mygraph:")
    print(mygraph.edges())
    
    print('Adding an edge {"x","y"} with new vertices:')
    mygraph.add_edge({"x","y"})
    print("Vertices of mygraph:")
    print(mygraph.vertices())
    print("Edges of mygraph:")
    print(mygraph.edges())
    
    mygraph.delete_vertex('y')
    mygraph.delete_vertex('x')
    # Howto draw a mygraph !
    print("now generate a dot file and png rendering!")
    print("if it fails, properly install mygraphviz")
    mygraph.print_dot("testgraph")


    # Now color with our heuristic
    mycolors = mygraph.color()
    print("colors are:")
    print(mycolors)
    # in 2021 colors are colorblind-adapted with shapes.
    mygraph.print_dot("testgraphcolor", mycolors)


if __name__ == '__main__':
    main()
